## Programming Language Resources

- C
    - [ANSI C Cheat Sheet](https://github.com/jwasham/google-interview-university/blob/master/extras/cheat%20sheets/C%20Reference%20Card%20(ANSI)%202.2.pdf)
    - K&R C book (ANSI C)
    - [Make, Clang (video)](https://www.youtube.com/watch?v=U3zCxnj2w8M)
    - GDB:
        - [Harvard CS50 - GDB (video)](https://www.youtube.com/watch?v=USPvePv1uzE)
        - [Harvard CS50 - GDB (video)](https://www.youtube.com/watch?v=y5JmQItfFck)
      - [Valgrind (video)](https://www.youtube.com/watch?v=fvTsFjDuag8)

- C++
    - [C++ Cheat Sheet](https://github.com/jwasham/google-interview-university/blob/master/extras/cheat%20sheets/Cpp_reference.pdf)
    - [STL Cheat Sheet](https://github.com/jwasham/google-interview-university/blob/master/extras/cheat%20sheets/STL%20Quick%20Reference%201.29.pdf)
    - basics
    - pointers
    - functions
    - references
    - templates
    - compilation
    - scope & linkage
    - namespaces
    - OOP
    - STL
    - [functors](http://www.cprogramming.com/tutorial/functors-function-objects-in-c++.html)
    - [C++ at Google (video)](https://www.youtube.com/watch?v=NOCElcMcFik)
    - [Google C++ Style Guide](https://google.github.io/styleguide/cppguide.html)
        - Google uses clang-format (there is a command line "style" argument: -style=google)
    - [Efficiency with Algorithms, Performance with Data Structures (video)](https://youtu.be/fHNmRkzxHWs)
    - [Review of C++ concepts (video)](https://www.youtube.com/watch?v=Rub-JsjMhWY)

- Python
    - [Python Cheat Sheet](https://github.com/jwasham/google-interview-university/blob/master/extras/cheat%20sheets/python-cheat-sheet-v1.pdf)
    - [Python in One Video](https://www.youtube.com/watch?v=N4mEzFDjqtA)
    - [Series on 3.4 (video)](https://www.youtube.com/playlist?list=PL6gx4Cwl9DGAcbMi1sH6oAMk4JHw91mC_)
    - [Zero to Hero (video)](https://www.youtube.com/watch?v=TV9tSHFAFjg)
    - [Statistics for Hackers (video)](https://www.youtube.com/watch?v=Iq9DzN6mvYA)
    - [Faster Python (video)](https://www.youtube.com/watch?v=JDSGVvMwNM8)
    - [CPython Walk (video)](https://www.youtube.com/watch?v=LhadeL7_EIU&list=PLzV58Zm8FuBL6OAv1Yu6AwXZrnsFbbR0S&index=6)
    - [10 Tips for Pythonic Code (video)](https://www.youtube.com/watch?v=_O23jIXsshs)
    - [Beyond PEP 8 -- Best practices for beautiful intelligible code (video)](https://www.youtube.com/watch?v=wf-BqAjZb8M)
    
- Java
    - [Stanford CS106A - Programming Methodology (video)](https://see.stanford.edu/Course/CS106A)
    - [Software Construction In Java (video)](https://www.edx.org/course/software-construction-java-mitx-6-005-1x)
    - [Introduction To Programming In Java](http://introcs.cs.princeton.edu/java/home/)
    - [Algorithms 4th Ed - Algorithm Book In Java](http://algs4.cs.princeton.edu/home/)   
- Go
    - [The Go programming Language](https://golang.org/)
    - [The Go programming Language (book)](http://www.gopl.io/)
    - [A Tour of Go](https://tour.golang.org/)
    - [Effective Go](https://golang.org/doc/effective_go.html)
    - [Go Wiki](https://golang.org/wiki)
    - [Go at Google: Language Design in the Service of Software Engineering](https://talks.golang.org/2012/splash.article)
    - [Go Proverbs](http://go-proverbs.github.io/)
    - [Go Proverbs - Rob Pike (video)](https://www.youtube.com/watch?v=PAAkCSZUG1c)
- Other Language 1
- Other Language 2
- etc
